<?php
/*
Plugin Name: routingPlugin
Plugin URI: http://www.adjust.ne.jp
Description: ルーティング拡張プラグイン
Author: ADjust Co.,Ltd.
Author URI: http://www.adjust.ne.jp
Version: 1.0
*/

add_filter('category_rewrite_rules', 'addDateRewriteRules');
add_filter('init', 'rewriteFlush');

function rewriteFlush()
{
  global $wp_rewrite;
  $wp_rewrite->flush_rules();
}

function addDateRewriteRules($rewrite_rules)
{
  $newRule = array();

  foreach($rewrite_rules as $key => $value)
  {
    if (!preg_match('/page/', $value) && !preg_match('/feed/', $value))
    {
      $str = preg_replace('/\?\$/', '', $key);

      //年別
      $newRule[$str.'date/([0-9]{4})/?$'] = $value.'&year=$matches[2]';
      $newRule[$str.'date/([0-9]{4})/page/?([0-9]{1,})/?$'] = $value.'&year=$matches[2]&paged=$matches[3]';
      //月別
      $newRule[$str.'date/([0-9]{4})/([0-9]{2})/?$'] = $value.'&year=$matches[2]&monthnum=$matches[3]';
      $newRule[$str.'date/([0-9]{4})/([0-9]{2})/page/?([0-9]{1,})/?$'] = $value.'&year=$matches[2]&monthnum=$matches[3]&paged=$matches[4]';
      //日別
      $newRule[$str.'date/([0-9]{4})/([0-9]{2})/([0-9]{1,2})/?$'] = $value.'&year=$matches[2]&monthnum=$matches[3]&day=$matches[4]';
      $newRule[$str.'date/([0-9]{4})/([0-9]{2})/([0-9]{1,2})/page/?([0-9]{1,})/?$'] = $value.'&year=$matches[2]&monthnum=$matches[3]&day=$matches[4]&paged=$matches[5]';
    }
  }

  return $newRule + $rewrite_rules;
}
